from trainer import train

#%% BosphorusSign22k-General

from dataset_BoSignGeneral import SLRDataset as ds
from dataset_BoSignGeneral_mhi import SLRDataset as ds_mhi

comp='nocompleted'

for act in ['ReLU', 'RReLU']:
    for data in ['raw','hands','mergehands','body','face',
                 'raw_mhi_1','hands_mhi_1','finger_mhi','body_mhi_1','face_mhi_1',
                 'raw_mhi_3','hands_mhi_3','body_mhi_3','face_mhi_3']:
        
        if data == 'mergehands':
            size_value = (56, 112)
        else:
            size_value = (112, 112)  
    
        parameters = {
          'project_name':'BoSignGeneral',
          'completed': comp,
          'model_name':'resnet18custom',
          'dataset_name': data,
          'size': size_value,
          'bs':8,
          'num_classes':174,
          'act': act,
        }
        
        md1, trn = train(parameters,ds, ds_mhi)


#%% BosphorusSign22k-General - Linear Interpolation

comp='completed'

for data in ['hands','mergehands','body',
             'finger_mhi', 'hands_mhi_3','body_mhi_3']:
    
    if data == 'mergehands':
        size_value = (56, 112)
    else:
        size_value = (112, 112)  

    parameters = {
      'project_name':'BoSignGeneral',
      'completed': comp,
      'model_name':'resnet18custom',
      'dataset_name': data,
      'size': size_value,
      'bs':8,
      'num_classes':174,
      'act': 'RReLU',
    }
    
    md1, trn = train(parameters,ds, ds_mhi)

#%% BosphorusSign22k

from dataset_BoSignFULL import SLRDataset as ds
from dataset_BoSignFULL_mhi import SLRDataset as ds_mhi

comp='completed'

for data in ['hands','mergehands','body','face',
             'finger_mhi', 'hands_mhi_3','body_mhi_3','face_mhi_3']:
    
    if data == 'mergehands':
        size_value = (56, 112)
    else:
        size_value = (112, 112)  

    parameters = {
      'project_name':'BoSignFULL',
      'completed': comp,
      'model_name':'resnet18custom',
      'dataset_name': data,
      'size': size_value,
      'bs':8,
      'num_classes':174,
      'act': 'RReLU',
    }
    
    md1, trn = train(parameters,ds, ds_mhi)


#%% LSA

from dataset_LSA import SLRDataset as ds
from dataset_LSA_mhi import SLRDataset as ds_mhi

comp='completed'

for exp in ['e1','e2']:
    for data in ['hands','mergehands','body','face',
                 'finger_mhi', 'hands_mhi_3','body_mhi_3','face_mhi_3']:
        
        if data == 'mergehands':
            size_value = (56, 112)
        else:
            size_value = (112, 112)  
    
        parameters = {
          'project_name':'LSA_'+exp,
          'completed': comp,
          'model_name':'resnet18custom',
          'dataset_name': data,
          'size': size_value,
          'bs':8,
          'num_classes':174,
          'act': 'RReLU',
          'experiments':exp
        }
        
    md1, trn = train(parameters,ds, ds_mhi)


usr_list = ['001','002','003','004','005','006','007','008','009','010']
for usr in usr_list:
    for data in ['hands','mergehands','body','face',
                 'finger_mhi', 'hands_mhi_3','body_mhi_3','face_mhi_3']:
        
        if data == 'mergehands':
            size_value = (56, 112)
        else:
            size_value = (112, 112)  
    
        parameters = {
          'project_name':'LSA_'+'e3',
          'completed': comp,
          'model_name':'resnet18custom',
          'dataset_name': data,
          'size': size_value,
          'bs':8,
          'num_classes':174,
          'act': 'RReLU',
          'experiments':'e3',
          'usr':usr
        }
        
    md1, trn = train(parameters,ds, ds_mhi)

        
#%% GSL

from dataset_GSL import SLRDataset as ds
from dataset_GSL_mhi import SLRDataset as ds_mhi

comp='completed'

for data in ['hands','mergehands','body','face',
             'finger_mhi', 'hands_mhi_3','body_mhi_3','face_mhi_3']:
    
    if data == 'mergehands':
        size_value = (56, 112)
    else:
        size_value = (112, 112)  

    parameters = {
      'project_name':'GSL',
      'completed': comp,
      'model_name':'resnet18custom',
      'dataset_name': data,
      'size': size_value,
      'bs':8,
      'num_classes':174,
      'act': 'RReLU',
    }
    
    md1, trn = train(parameters,ds, ds_mhi)