from extract_features import extract
import h5py
import glob

def write_hdf5(file, data, key):
    with h5py.File(str(file),'a') as ds:
        ds[key] = data

root = ".../path_saved_datas.../"

path_pose_data = ".../path_pose_data.../"

path_body = root +'body.hdf5'
path_body_mhi_1 = root +'body_mhi_1.hdf5'
path_body_mhi_3 = root +'body_mhi_3.hdf5'

path_hands = root +'hands.hdf5'
path_hands_mhi_1 = root +'hands_mhi_1.hdf5'
path_hands_mhi_3 = root +'hands_mhi_3.hdf5'

path_mergedhands = root +'mergedhands.hdf5'

path_face = root +'face.hdf5'
path_face_mhi_1 = root +'face_mhi_1.hdf5'
path_face_mhi_3 = root +'face_mhi_3.hdf5'

path_raw = root +'raw.hdf5'
path_raw_mhi_1 = root +'raw_mhi1.hdf5'
path_raw_mhi_3 = root +'raw_mhi3.hdf5'

path_finger_mhi = root +'mhi_finger.hdf5'

pose_datasets = glob.glob(path_pose_data + '/*.pkl')

path_video_data = ".../path_video_dataset.../"

size_dataset = len(pose_datasets)

for idx, path_pose in enumerate(pose_datasets):
    
    key = path_pose.split('/')[-1].split('.')[0]
    path_video = path_video_data+ path_pose.split('/')[-1].split('.')[0] + '.mp4'
    results = extract(path_pose, path_video)
    
    write_hdf5(path_body, results['body'], key)
    write_hdf5(path_body_mhi_1, results['body_mhi_1'], key)
    write_hdf5(path_body_mhi_3, results['body_mhi_3'], key)

    write_hdf5(path_hands, results['hands'], key)
    write_hdf5(path_hands_mhi_1, results['hands_mhi_1'], key)
    write_hdf5(path_hands_mhi_3, results['hands_mhi_3'], key)
    write_hdf5(path_mergedhands, results['mergedhands'], key)    
    
    write_hdf5(path_face, results['face'], key)
    write_hdf5(path_face_mhi_1, results['face_mhi_1'], key)
    write_hdf5(path_face_mhi_3, results['face_mhi_3'], key)

    write_hdf5(path_raw, results['raw'], key)
    write_hdf5(path_raw_mhi_1, results['raw_mhi_1'], key)
    write_hdf5(path_raw_mhi_3, results['raw_mhi_3'], key)

    write_hdf5(path_finger_mhi, results['finger_mhi'], key)

    print(f"{idx+1} / {size_dataset}")
